import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.awt.geom.*;
import java.math.*;



public class PictureCanvas extends ScaleCanvas implements MouseListener {
    Manager M;
    int[][] box=new int[1001][1001];

    public PictureCanvas addManager(Manager M) {
	PictureCanvas Q=this;
	Q.M=M;
	return(Q);
    }

     public PictureCanvas() {
	 addMouseListener(this);
	 box[500][0]=1; 
	 doCenter();
	 setBoxes();

     }


    public void setBoxes() {

      for(int j=1;j<500;++j)
	 computeLayer(j);

    }


   public void paint(Graphics g2) {
      Graphics2D g=(Graphics2D) g2;
      g.setRenderingHint(RenderingHints.KEY_ANTIALIASING,RenderingHints.VALUE_ANTIALIAS_ON);
      g.setColor(Color.black);
      g.fillRect(0,0,getWidth(),getHeight());
      drawBoxes(g);  
   }


    public void drawBoxes(Graphics2D g) {
	int LIM=M.C.I[0].val;
	for(int i=-LIM-2;i<LIM+3;++i) {
	    for(int j=0;j<=LIM;++j) {
		try{
	   	   if((i+j)%2==0) drawBox(g,i,j);
		}
		catch(Exception e) {}
	    }
	}
    }

    public void doCenter() {
	int w=getWidth();
	double d=32;
	setScales(w/2,d,d);
    }

    public void doFit() {
	int w=getWidth();
	double d1=getHeight()-27;
	double d2=M.C.I[0].val+2.0;
	double d3=1.0*d1/d2;
	setScales(w/2,d3,d3);
    }


    public static BigInteger factorial(int n) {
	BigInteger B1=new BigInteger("1");
	for(int i=2;i<=n;++i) {
	    Integer II=new Integer(i);
	    BigInteger B2=new BigInteger(II.toString());
	    B1=B1.multiply(B2);
	}
	return(B1);
    }

    public static BigInteger choose(int n,int k) {
	BigInteger B1=factorial(n);
	BigInteger B2=factorial(k);
	BigInteger B3=factorial(n-k);
	B1=B1.divide(B2);
	B1=B1.divide(B3);
	return(B1);
    }

    public int[] getBox() {
	int[] ii={-999,-999};
	int LIM=M.C.I[0].val;
	for(int i=-LIM-2;i<LIM+3;++i) {
	    for(int j=0;j<=LIM;++j) {
		if((i+j)%2==0) {
                   GeneralPath gp=new GeneralPath();
	           gp.moveTo(i-1,j-0);
	           gp.lineTo(i-0,j-1);
	           gp.lineTo(i+1,j-0);
	           gp.lineTo(i-0,j+1);
	           gp.closePath();
	           if(gp.contains(SOURCE.x,SOURCE.y)==true) {
		       ii[1]=(i+j)/2;ii[0]=j;
		     return(ii);
		   }
		}
	    }
	}
	return(ii);
    }


    public void doRecognize() {
	int[] test=getBox();
	BigInteger B=PascalMath.choose(test[0],test[1]);
	M.C.VALUE=B.toString();
    }




    public void drawBox(Graphics2D g,int i,int j) {
	double d=getScale();
	Path2D.Double gp=new Path2D.Double();
	gp.moveTo(i-1,j-0);
	gp.lineTo(i-0,j-1);
	gp.lineTo(i+1,j-0);
	gp.lineTo(i-0,j+1);
	gp.closePath();
	gp=transform(gp);
        g.setFont(new Font("Helvetica",Font.PLAIN,50));
	int VAL=box[i+500][j];
	g.setColor(M.C.COL[VAL].C);
	g.fill(gp);

	int[] v=center(gp);


	if((M.C.I[0].val<6)&&(j<6)) {
   	    g.setColor(Color.black);
	    int k=(i+j)/2;
	    BigInteger H=PascalMath.choose(j,k);
	    String HH=H.toString();
	    if((j==0)&&(k!=0)) HH="0";
	    int h=H.intValue();
	    g.drawString(HH,v[0]-15-h,v[1]+20);

	}
	g.setColor(M.C.COL[VAL].C);
	if(M.C.EDGE.on==1)  
        g.setColor(new Color(150,150,150));
	g.draw(gp);
    }


    public void computeLayer(int k) {
	int MOD=2;
	try{ MOD=M.C.I[1].val;}
	catch(Exception e) {}
	for(int i=-499;i<500;++i) {
	    int test=box[i-1+500][k-1]+box[i+1+500][k-1];
	    test=test%MOD;
	    box[i+500][k]=test;
	}
    }

    public void mousePressed(MouseEvent e) {
    }

    public void mouseClicked(MouseEvent e) {    
         MouseData J=MouseData.process(e);
         if(J.mode==3)  scaleUp(J.X,0);
         if(J.mode==1)  scaleUp(J.X,1);
	 if(J.mode==2) {
	     SOURCE=unTransform(J.X);
	     doRecognize();
	     M.C.repaint();
	 }
	 repaint();
    }

     public void mouseReleased(MouseEvent e) {}
     public void mouseEntered(MouseEvent e) {}
     public void mouseExited(MouseEvent e) {}   


    public static int[] center(Path2D.Double gp) {
	Rectangle2D R0=gp.getBounds2D();
	Rectangle2D.Double R1=(Rectangle2D.Double)(R0);
	int[] v={0,0};
	v[0]=(int)(R1.x+R1.getWidth()/2);
	v[1]=(int)(R1.y+R1.getHeight()/2);
	return v;
    }
}